/*
 * utility.c
 *
 *  Created on: Mar 25, 2015
 *      Author: Pedro
 */

/*
 * ======== Standard MSP430 includes ========
 */
#include <msp430.h>

#include <stdlib.h>
#include  <stdint.h>


/*
 * ======== Grace related includes ========
 */
#include <ti/mcu/msp430/Grace.h>

void OUTA_UART(unsigned char A, unsigned int sel);
void send_UART(char *str, unsigned int sel);

int8_t strcmp (const uint8_t* s1, const uint8_t* s2); // testing this strcmp

//Circular Queue
volatile unsigned char btque[100], stnque[100];
volatile unsigned int btfront =0, btrear=0, stnfront =0, stnrear =0;
volatile unsigned int isbtempty = 1, isstnempty = 1;


/* Sending uart strings, helper functions
 *  Sel = 0 -> USCIA0 (STN1110)
 * Sel = 1 -> USCIA1 (RN4020)
 */
void send_UART(char *str, unsigned int sel)		// Function for printing a string character by character

{
	unsigned int k;

	for(k=0;str[k]!=0x00;k++)
	{
		OUTA_UART(str[k], sel);
	}

	OUTA_UART(0x0D, sel); // all commands end in carriage return

}

int8_t strcmp (const uint8_t* str1, const uint8_t* str2)
{
	unsigned const char *s1 = (unsigned const char *) str1;
	unsigned const char *s2 = (unsigned const char *) str2;
	while (*s1 && *s1 == *s2)
	{
	        ++s1;
	        ++s2;
	}

	  return (int8_t)( (int16_t)*s1 - (int16_t)*s2 );
}

void OUTA_UART(unsigned char A, unsigned int sel){
//---------------------------------------------------------------
//***************************************************************
//---------------------------------------------------------------
// IFG2 register (1) = 1 transmit buffer is empty,
// UCA0TXBUF 8 bit transmit buffer
// wait for the transmit buffer to be empty before sending the
// data out

	if(sel==0)
	{
		while (!(IFG2&UCA0TXIFG));
		// send the data to the transmit buffer
		UCA0TXBUF =A;
	}
	else
	{

		while (!(UC1IFG&UCA1TXIFG));
		// send the data to the transmit buffer
		UCA1TXBUF =A;
	}

}// end funct


